package Archive::MoPaQ;

use 5.008008;
use strict;
use warnings;

our $VERSION = '0.01';

require XSLoader;
XSLoader::load('Archive::MoPaQ', $VERSION);

sub new {
	my $class = shift;
	my $self = Archive::MoPaQ->init;
	bless $self, $class;
}

1;

__END__

=head1 NAME

Archive::MoPaQ - Interface to libmpq archive library

=head1 SYNOPSIS

  use Archive::MoPaQ;
  my $mpq = Archive::MoPaQ->new;
  $mpq->open("ladder/(4)Lost Temple.scm" or die;
  $mpq->extract(1); # write map to file000001.xxx

=head1 DESCRIPTION

Preliminary interface to libmpq, under development.

=head1 SEE ALSO

The I<libmpq> library.

=head1 AUTHOR

Mischa POSLAWSKY <perl@shiar.org>

=head1 COPYRIGHT AND LICENSE

Undefined.

=cut
